#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	ofBackground(0, 20, 20);
	//angle = 0;
	startTime = ofGetElapsedTimef();
	
	
	for (int i = 0; i < 2000; i++){
		particle myParticle;
	
		
		float a = ofRandom(0, 2* PI);
		float r = ofRandom(0, 20.0);
		float vx = r * cos(a);
		float vy = r * sin(a);
		myParticle.setInitialCondition(ofGetWidth()/2,ofGetHeight()/2,vx, vy);
		// more interesting with diversity :)
		// uncomment this: 
		//myParticle.damping = ofRandom(0.005, 0.03);
		particles.push_back(myParticle);
	}
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		particles[i].addForce(0,ofRandom(0.01, 0.45));  // gravity
		particles[i].addDampingForce();
		particles[i].update();
	}
	 Redraw();
	 
	
}

//--------------------------------------------------------------
void testApp::draw(){
	ofSetColor(0x000000);
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
	}

	

}
//--------------------------------------------------------------
void testApp::Redraw(){


	
	if( (ofGetElapsedTimef() - startTime) > 5.0 ){
		startTime = ofGetElapsedTimef();						//resetting the value
		for (int i = 0; i < particles.size(); i++){

		float a = ofRandom(0, 2 * PI);
		float r = ofRandom(0,20);
		float vx = r * cos(a);
		float vy = r * sin(a);
		particles[i].setInitialCondition(ofGetWidth()/2,ofGetHeight()/2,vx, vy);	
	
	}


		
	}
	
	



}	
//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
//	for (int i = 0; i < particles.size(); i++){
//
//		
//		float a = ofRandom(0, 2 * PI);
//		float r = ofRandom(0,20);
//		float vx = r * cos(a);
//		float vy = r * sin(a);
//		particles[i].setInitialCondition(mouseX,mouseY,vx, vy);	
//	
//	}
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
